﻿@layout None
@page "/"
@inject ILoginService LoginService;
@using SquirtingElephant.WebApp.Layouts
@using SquirtingElephant.WebApp.Interfaces
@using SquirtingElephant.WebApp.Models.Request
@inject ILocalStorageService LocalStorageService
@inject NavigationManager NavigationManager

<div class="login-background">
    <div class="row height-90-p no-margins">
        <div class="col-sm-12 col-md-4 offset-md-4 align-self-center">
            <div class="row">
                <div class="col-sm col-md-8 offset-md-2 horizontal-center  align-self-center">
                    <div class="card  card-login card-border">
                        <div class="card-header">
                            <div class="card-header">
                                <h3 class="text-center">Login</h3>
                            </div>
                        </div>
                        <div class="card-body">
                            <EditForm Model="LoginRequest" class="form-horizontal"
                                      novalidate>
                                <div class="row">
                                    <div class="col-sm">
                                        <div class="form-group">
                                            <InputText @bind-Value="LoginRequest.Email"
                                                       class="form-control"
                                                       type="email"
                                                       placeholder="Enter Email"
                                                       required />
                                        </div>
                                        <div class="form-group">
                                            <InputText @bind-Value="LoginRequest.Password"
                                                       class="form-control"
                                                       type="password"
                                                       placeholder="Enter Password"
                                                       required />
                                        </div>
                                    </div>
                                </div>
                                <div class="col-sm text-center">
                                    <button type="button"
                                            @onclick="Login"
                                            class="btn btn-primary btn-block btn-round">
                                        <span>Login</span>
                                    </button>
                                </div>
                                <br>
                                <div class="col-sm">
                                    @Error
                                </div>
                            </EditForm>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>


@code {
    private string Email { get; set; }
    private LoginRequest LoginRequest { get; set; } = new LoginRequest();
    private string Password { get; set; }
    private bool IsRunning { get; set; }
    public string Error { get; set; }

    private async Task Login()
    {
        try
        {
            IsRunning = true;
            var (loginResponse, errorResponse) = await LoginService.Login(LoginRequest);
            if (loginResponse != null)
            {
                await LocalStorageService.SetItemAsync(nameof(loginResponse.access_token), loginResponse.access_token);
                await LocalStorageService.SetItemAsync(nameof(loginResponse.id_token), loginResponse.id_token);
                await LocalStorageService.SetItemAsync(nameof(loginResponse.expires_in), loginResponse.expires_in);
                await LocalStorageService.SetItemAsync(nameof(loginResponse.refresh_token), loginResponse.refresh_token);
                NavigationManager.NavigateTo("/HomePage");
            }
            else
            {
                Error = errorResponse.Message;
            }
        }
        catch (Exception e)
        {
            Console.WriteLine(e);
        }
        finally
        {
            IsRunning = false;
        }
    }
}